using System;
using System.IO;

namespace SpanishStemmerApp
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class SSApp
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{	
			if (Environment.GetCommandLineArgs().Length > 1)
			{	bool first = true;
				foreach (string arg in Environment.GetCommandLineArgs())
				{
					//ignore the first 
					if (first) {first = false;}
					else {stemText(arg);}					
				}
			}
			else { Console.WriteLine("Please enter an input file.");}
		}

		static private void stemText(string filename)
		{
			try
			{	StreamReader SR;
				StreamWriter SW;

				if (! File.Exists(filename)) {throw new Exception();}

				SR = new StreamReader(@filename, System.Text.Encoding.Default);
				string dir = Path.GetDirectoryName(filename);
				string filenoext = Path.GetFileNameWithoutExtension(filename);
				string newfile = dir + "\\" + filenoext + ".out";
				SW = new StreamWriter(@newfile, false, System.Text.Encoding.Default); 					
				Console.WriteLine("Writing file " + newfile);

				string S;			
				S = SR.ReadLine();
				while (S != null)
				{		// Replace characters that are not letters or numbers with spaces
						S = replaceSymbols(S);
						// Split the string into a word array
						string[] wordsArray = S.Split(" ".ToCharArray());
						// Stem each word.
						for (int i = 0; i < wordsArray.Length; i++)
						{
							if ( wordsArray[i] != " ")
							{
								SW.WriteLine(SpanishStemmer.stemWord(wordsArray[i]));
							}
						}	
					S = SR.ReadLine();
				}
				SR.Close();
				SW.Close();
			}
			catch(Exception){Console.WriteLine("Cannot open file "+ filename);}
		}

		static private string replaceSymbols(string S)
		{	string newstr = "";
			for (int i = 0; i < S.Length; i++)
			{ 
			  if (Char.IsLetter(S[i]) || Char.IsNumber(S[i]))
				{newstr += S[i];}  
	    	  else { newstr += ' ';}     			
			}		
			
			return newstr;
		}
	}
}
